C     PROGRAM XSCOPY=UMSBIB, OLD PROGRAM OF THE REAL-84 EXECISE
C     MODIFIED BY M. MATZKE
C     TRANSFORMATION OF CS640-LIBRARY IN BINARY FILE
C     NAME OF BINARY FILE IS ASKED
C
C     THIS PROGRAM MAKES AN UNFORMATTED COPY OF THE X-SECTION LIBRARY
C
C     TAPE25 = 42ND FILE OF THE REAL84 TAPE
C	       (SAND-II TYPE X-SECTION LIBRARY IN 640 GROUPS)
C     TAPE15 = UNFORMATTED LIBRARY
C
      DIMENSION E(641),X(640)
      CHARACTER*14 LISTE,LISTE1
      CHARACTER*4 CN1,CN2,S(2),F(4)
      DATA LISTE1 /'              '/
C
C     E = ENERGY IN MEV
C     X = X-SECTION IN M**2
C     S = REACTION CODE
C     F = REACTION FULL NAME
C
C*************************************************************
      LISTE=LISTE1
C
      WRITE(*,500)
  500 FORMAT(
     1' GIVE NAME OF INPUT FILE OR TERMINAL IDENTIFICATION (CON):'/)
      READ(*,501,ERR=502,END=502) LISTE1
  501 FORMAT(A14)
  502 OPEN(5,FILE=LISTE1)
      LISTE1=LISTE
C
      WRITE(*,503)
  503 FORMAT(
     1' GIVE NAME OF PRINTER FILE OR PRINTER IDENTIFICATION (LPT1):'/)
      READ(5,501,ERR=504,END=504) LISTE1
  504 OPEN(6,FILE=LISTE1)
      liste1=liste
C***************************************************************
      WRITE(6,3322)
 3322 FORMAT('  '/
     *' TRANSFORMATION OF LIBRARY (CS640)'/
     *' INTO BINARY FILE  ************* PROGRAM UMSBIB****'/
     *' (OLD PROGRAM XSCOPY, MODIFIED BY M. MATZKE'/
     *' VERSION 87-11')
C*****************************************************************
      write(*,7223)
 7223 format('  give factor for multiplication with all'/
     *' cross sections'/)
      read(5,*) fact
      write(6,7224) fact
 7224 format(' '/' all cross sections are multiplied by  ',e12.5/)
C************************************************************
      LISTE=LISTE1
      WRITE(*,1222)
 1222 FORMAT(' NAME OF FILE 25, INPUT FORMATTED CROSS SECTION FILE ?'/
     *' E.G. THE RESPONSE OUTPUT FILE OF A MRESBI-RUN'/)
      READ(5,2000,END=112,ERR=112) LISTE
 2000 FORMAT(A12)
  112 CONTINUE
      OPEN(25,FILE=LISTE,STATUS='OLD',FORM='FORMATTED')
      WRITE(6,8100) LISTE
 8100 FORMAT(' INPUT FORMATTED CROSS SECTION  FILE: ',A14)
C*************************************************************
C************************************************************
      LISTE=LISTE1
      WRITE(*,2222)
 2222 FORMAT(' NAME OF FILE 15, OUTPUT BINARY CROSS SECTION FILE ?'/)
      READ(5,2000,END=1132,ERR=1132) LISTE
 1132 CONTINUE
      OPEN(15,FILE=LISTE,STATUS='NEW',FORM='UNFORMATTED')
      WRITE(6,8101) LISTE
 8101 FORMAT(' OUTPUT CROSS SECTION BINARY FILE: ',A14)
C*************************************************************
C
      READ (25,80) MPL1
      M=MPL1-1
C
C     MPL1 = NUMBER OF ENERGY POINTS
C     M    = NUMBER OF ENERGY GROUPS
C
   80 FORMAT (I10)
      WRITE (6,120) MPL1,M
  120 FORMAT (' '//7H MPL1 =,I10/4H M =,I13)
      WRITE (15) MPL1
      READ (25,81) (E(J),J=1,MPL1)
   81 FORMAT (1P,8E10.3)
      WRITE (6,121) (E(J),J=1,MPL1)
  121 FORMAT (4H0E =/(1P,10E12.3))
      WRITE (15) (E(J),J=1,MPL1)
      READ (25,80) NC
C
C     NC = NUMBER OF COVER MATERIALS
C
      WRITE (6,122) NC
  122 FORMAT (5H0NC =,I10)
      WRITE (15) NC
      DO 1 N=1,NC
      READ (25,82) CN
   82 FORMAT (A2)
C
C     CN = COVER MATERIAL CODE
C
      WRITE (6,123) CN
  123 FORMAT (13X,A2)
      WRITE (15) CN
      READ (25,81) (X(J),J=1,M)
      do 2378 j1=1,m
 2378 x(J1)=x(J1)*fact
    1 WRITE (15) (X(J),J=1,M)
      READ (25,80) NL
C
C     NL = NUMBER OF CROSS SECTION SETS IN THE LIBRARY
C
      WRITE (6,124) NL
  124 FORMAT (5H0NL =,I10)
      WRITE (15) NL
      DO 2 N=1,NL
      READ (25,83) S,F
   83 FORMAT (2A4,2X,4A4)
      WRITE (6,125) N,S,F
  125 FORMAT (I5,5X,2A4,2X,4A4)
      WRITE (15) S,F
      READ (25,84) CLAM,CN1,CN2,MAT,MT
C
C     CLAM = DECAY CONSTANT (LAMBDA) IN S**-1
C     CN1  = NAME OF THE ISOTOPE FOR WHICH THE DECAY CONSTANT IS GIVEN,
C	     FIRST PART
C     CN2  = CONTINUATION OF THE NAME
C     MAT  = MATERIAL NUMBER IN THE ORIGINAL LIBRARY
C	     OF THE ENDF/B-V FORMAT
C     MT   = REACTION NUMBER IN THE ORIGINAL LIBRARY
C	     OF THE ENDF/B-V FORMAT
C
   84 FORMAT (1P,E10.3,2A4,2X,2I10)
      WRITE (6,126) CLAM,CN1,CN2,MAT,MT
  126 FORMAT (' ',19X,'LAM=',1P,E10.3,'   (',2A4,')'/
     1' ',19X,'MAT=',I6,'  MT=',I6)
C
C     THE SAND-II CODE NEEDS THE CLAM ONLY (CN1,CN2,MAT AND MT
C     ARE NOT READ BY IT), THE NEXT WRITE STATEMENT CAN BE MODIFIED
C
      WRITE (15) CLAM,CN1,CN2,MAT,MT
      READ (25,81) (X(J),J=1,M)
      do 7834 j=1,m
 7834 x(j)=x(J)*fact
    2 WRITE (15) (X(J),J=1,M)
      ENDFILE 15
      STOP
      END
