C     PROGRAM XSC32F           MODIFIED BY M. MATZKE   VERSION 90-11
C     NEW NAME FOR IRDF-90.MTZ: XSC32M90
C
C
C     THIS PROGRAM MAKES A DIRECT ACCESS LIBRARY OF THE X-SECTION
C     COVARIANCE MATRICES OF TYPE 32 FOR NEPTUNIUM
C
C     TAPE6  = TERMINAL OUTPUT , NAMED CON
C     TAPE16 = NEW LIBRARY
C     TAPE35 = NEPT.COV
C              (NP237F COVARIANCE MATRIX IN COMPRESSED FORM)
C
      CHARACTER*4 HEAD(20),NAME(2)
      CHARACTER*8 NAMEE
      DIMENSION COV(641),COW(641),ENER(641),
     1   NLIB(1),MATI(1),IREI(1)
      EQUIVALENCE (NAME(1),NAMEE)
      OPEN(35,FILE='NEPT.COV')
      OPEN(6,FILE='CON')
C     DEFINE FILE 16 (0,0,W,NWR)
      OPEN(16,FILE='XSC1',STATUS='NEW',ACCESS='DIRECT',RECL=2564,FORM=
     *'UNFORMATTED')
      NWR=1
      NLIB(1)=1
      READ(35,1) HEAD
      WRITE(16,REC=1) HEAD
C     CALL WDA(NWR,HEAD,20)
      BACKSPACE 35
      WRITE(16,REC=2) NLIB
C     CALL WDA(NWR,NLIB,1)
      MU=2
      inp=35
      READ (INP,1) HEAD
    1 FORMAT (20A4)
C     CALL WDA(1,HEAD,20)
      WRITE(6,2611) HEAD
 2611 FORMAT(' ',20A4)
      READ (INP,2) MATI
C
 2755 FORMAT(1H ,2I5)
C
      MU=MU+1
      NWR=MU
      WRITE(6,3755) NWR,MATI
 3755 FORMAT(' NWR,MAT:',2I6)
      CALL WDA(NWR,MATI,1)
    2 FORMAT (I5)
      READ (INP,2) IREI
      MU=MU+1
      NWR=NWR+1
      WRITE(6,3756) NWR,IREI
 3756 FORMAT(' NWR,IREI',2I6)
      CALL WDA(NWR,IREI,1)
      KREI=IREI(1)
      DO 20 IRE=1,KREI
      READ (INP,3) NAME(1),NAME(2),LENIJ
    3 FORMAT (2A4,2X,I10)
      WRITE(6,3721) NAME(1),NAME(2),LENIJ
 3721 FORMAT(1H ,2A4,' N=',I10)
      LENIP1=LENIJ+1
      MU=MU+1
      NWR=NWR+1
      CALL WDAC(NWR,NAMEE)
      WRITE(6,8755) NWR,NAME,LENIJ
 8755 FORMAT(' NWR=',I5,'  ',2A4,' LENIJ=',I5)
      MU=MU+1
      NWR=NWR+1
      WRITE(16,REC=NWR) LENIJ
      WRITE(6,7321) NWR,LENIJ
 7321 FORMAT(' NWR=',I6,'  LENIJ=',I6)
      MU=MU+1
      NWR=MU
      READ (INP,5) (ENER(J),J=1,LENIP1)
      WRITE(6,3768) NWR,LENIP1
      CALL WDA1(NWR,ENER,LENIP1)
C
 3768 FORMAT(' NWR,LENIP1  :',2I6,'  (NWR: RECORD FOR ENERGY')
      DO 10 LEN=1,LENIJ
      READ (INP,5) (COV(J),J=1,LEN)
      MU=MU+1
      NWR=MU
      CALL WDA1(NWR,COV,LEN)
    5 FORMAT (10F8.3)
   10 CONTINUE
      WRITE(6,7322) NWR
 7322 FORMAT(' LAST RECORD IN THIS LOOP: ',I6)
   20 continue
      MU=5
      NL=NLIB(1)
      DO 50 K=1,NL
      CALL RDAC(MU,NAMEE)
      MU=MU+1
      READ(16,REC=MU) LENIJ
      WRITE(6,5421) MU,NAME(1),NAME(2),LENIJ
 5421 FORMAT(' RECORD FOR LENIJ: ',I6,' NAME: ',2A4,'  LENIJ=',I10)
      MUN=MU+LENIJ+4
      MU=MU+1
      LENIM1=LENIJ-1
      DO 40 I=1,LENIM1
      MUPI=MU+I
      CALL RDA1(MUPI,COV,I)
      DO 30 J=2,LENIJ
      MUPJ=MU+J
      CALL RDA1(MUPJ,COW,J)
      COV(J)=COW(I)
   30 CONTINUE
      CALL WDA1(MUPI,COV,LENIJ)
   40 CONTINUE
      MU=MUN
   50 CONTINUE
      WRITE (6,60)
   60 FORMAT (1H1,'   THE STRUCTURE OF THE LIBRARY GENERATED')
      MU=1
      READ(16,REC=MU) HEAD
      WRITE (6,61) HEAD
   61 FORMAT(//5X,20A4)
      MU=MU+1
      CALL RDA(MU,NLIB,1)
      NL=NLIB(1)
      WRITE (6,62) NL
   62 FORMAT (//5X,44HNUMBER OF 'MAT' NUMBERS PRESENT IN LIBRARY =,I5)
      DO 80 K=1,NL
      MU=MU+1
      CALL RDA(MU,MATI,1)
      WRITE (6,63) MATI
   63 FORMAT (//5X,7H'MAT' =,I5)
      MU=MU+1
      CALL RDA(MU,IREI,1)
      WRITE (6,64) IREI
   64 FORMAT (/5X,35HNUMBER OF REACTIONS TO THIS 'MAT' =,I5)
      MU=MU+1
      CALL RDAC(MU,NAMEE)
      MU=MU+1
      READ(16,REC=MU) LENIJ
      WRITE (6,65) NAME,LENIJ
   65 FORMAT (/5X,69HREACTION CODE IN THE X-SECTION LIBRARY (FILE 42 ON
     1THE REAL84 TAPE) =,2A4/5X,25HNUMBER OF ENERGY GROUPS =,I5)
      LENIP1=LENIJ+1
      MU=MU+1
      CALL RDA1(MU,ENER,LENIP1)
      WRITE (6,66) (ENER(J),J=1,LENIP1)
   66 FORMAT (/5X,29HLOWER ENERGY BOUNDARIES IN EV/(1P,E17.3,9E12.3))
      DO 70 J=1,LENIJ
      MU=MU+1
      CALL RDA1(MU,COV,LENIJ)
      COW(J)=SQRT(COV(J))
      IF (J.GT.1.AND.J.LT.LENIJ) GO TO 70
      WRITE (6,67) J,(COV(L),L=1,LENIJ)
   67 FORMAT (I8,42H. COLUMN OF THE RELATIVE COVARIANCE MATRIX/
     1   (1P,E17.3,1P,9E12.3))
   70 CONTINUE
      WRITE (6,71) (COW(L),L=1,LENIJ)
   71 FORMAT (5X,28HRELATIVE STANDARD DEVIATIONS/(1P,E17.3,1P,9E12.3))
   80 CONTINUE
      STOP
      END
      SUBROUTINE WDA(NREC,NARRAY,LENGTH)
      DIMENSION NARRAY(LENGTH)
C     ----------------------------------
C     CDC FTN4 VERSION:
C     CALL WRITMS(16,ARRAY,641,NREC,0,0)
C     RETURN
C     ----------------------------------
C     IBM VERSION:
C     WRITE (16'NREC) NARRAY
      WRITE(16,REC=NREC) NARRAY
      RETURN
      END
C     =============================================================
      SUBROUTINE WDAC(NREC,NAMEE)
      CHARACTER*8 NAMEE
      WRITE(16,REC=NREC) NAMEE
      RETURN
      END
      SUBROUTINE RDAC(NREC,NAMEE)
      CHARACTER*8 NAMEE
      READ(16,REC=NREC) NAMEE
      RETURN
      END
C
      SUBROUTINE RDA(NREC,NARRAY,LENGTH)
      DIMENSION NARRAY(LENGTH)
C     -----------------
C     CDC FTN4 VERSION:
C     CALL READMS(16,ARRAY,LENGTH,NREC)
C     RETURN
C     -----------------
C     IBM VERSION:
C     READ (16'NREC) NARRAY
      READ(16,REC=NREC) NARRAY
      RETURN
      END
C     =============================================================
C
      SUBROUTINE UDA(NREC,ARRAY,LENGTH)
      DIMENSION ARRAY(LENGTH)
C     ----------------------------------
C     CDC FTN4 VERSION:
C     CALL WRITMS(16,ARRAY,641,NREC,1,0)
C     RETURN
C     ----------------------------------
C     IBM VERSION:
C     WRITE (16'NREC) ARRAY
      WRITE(16,REC=NREC) ARRAY
      RETURN
C     =============================================================
      END
      SUBROUTINE WDA1(NREC,ARRAY,LENGTH)
      DIMENSION ARRAY(LENGTH)
C     WRITE(16'NREC) ARRAY
      WRITE(16,REC=NREC) ARRAY
      RETURN
      END
      SUBROUTINE RDA1(NREC,ARRAY,LENGTH)
      DIMENSION ARRAY(LENGTH)
C     READ (16'NREC) ARRAY
      READ(16,REC=NREC) ARRAY
      RETURN
      END
